Subject: Re: bug#71924: 31.0.50; elpa.gnu.org has misleading link to bbdb source code

From: Philip Kaludercic <[email-masked]>
Date: Sun, 28 Jul 2024 11:59:02 +0000

Jules Tamagnan <[email-masked]> writes:

> ---
>
> * Background
>
> This might be expected but I found it a bit confusing so figured I would
> open a bug report in case it is not expected.
>
> The high level issue is that it seems like the elpa website is pointing
> to the wrong version of the bbdb source code.
>
> * Problem
>
> The `bbdb` package is defined in elpa as pulling from nongnu elpa. This
> can be seen here -
> https://git.savannah.gnu.org/cgit/emacs/elpa.git/tree/elpa-packages?h=main#n89
>
> However the link to `bbdb`'s source code from the elpa website
> (http://elpa.gnu.org/packages/bbdb.html) points to the gnu elpa version
> of the source code:
> https://git.savannah.gnu.org/cgit/emacs/elpa.git/?h=externals/bbdb.
>
> This causes confusion because the website does not point to the true
> source code that would be installed.
>
> This further causes confusion because both versions of `bbdb` are
> extremely different notably the elpa version of bbdb contains a
> `bbdb-site.el` file
> (https://git.savannah.gnu.org/cgit/emacs/elpa.git/tree/lisp/bbdb-site.el?h=externals/bbdb)
> whereas the non-gnu elpa version contains a `bbdb-site.el.in` file
> (https://git.savannah.nongnu.org/cgit/bbdb.git/tree/lisp/bbdb-site.el.in)
>
> * Desired solutions
>
> 1. The elpa website should link to the bbdb source code that is defined
>    in elpa-packages.

ELPA always mirrors the remote repositories, and links to this mirror,
but you can set the URL in the package header to point to whatever site
you like.

> 2. Both versions of the elpa source code:
>    https://git.savannah.gnu.org/cgit/emacs/elpa.git/tree/?h=externals/bbdb, and
>    https://git.savannah.nongnu.org/cgit/bbdb.git/tree/, should be reconciled.

If you merge the elpa branch into your branch and then adjust what you
want, it should go through.

> I'd be willing to tackle solution 1 and possibly solution 2 but it isn't
> clear to me where the source code for the elpa website is such that it
> can be modified to point to the expected URL. It also isn't clear to me
> if we should be keeping both versions of the source code or consolidate
> since it seems like the version on gnu.org is no longer in use.

> Best,
> Jules
>
> ---
>
> In GNU Emacs 31.0.50 (build 1, x86_64-pc-linux-gnu, GTK+ Version
> 3.24.42, cairo version 1.18.0)
> Repository revision: 9cb2a2040888c28587bed2b0902d9da90720f9a0
> Repository branch: master
> Windowing system distributor 'The X.Org Foundation', version 11.0.12101013
> System Description: NixOS 24.11 (Vicuna)
>
>
>
>

Jeremy Bryant <[email-masked]> writes:

> Jules Tamagnan <[email-masked]> writes:
>
>> ---
>>
>> * Background
>>
>> This might be expected but I found it a bit confusing so figured I would
>> open a bug report in case it is not expected.
>>
>> The high level issue is that it seems like the elpa website is pointing
>> to the wrong version of the bbdb source code.
>>
>> * Problem
>>
>> The `bbdb` package is defined in elpa as pulling from nongnu elpa. This
>> can be seen here -
>> https://git.savannah.gnu.org/cgit/emacs/elpa.git/tree/elpa-packages?h=main#n89
>>
>> However the link to `bbdb`'s source code from the elpa website
>> (http://elpa.gnu.org/packages/bbdb.html) points to the gnu elpa version
>> of the source code:
>> https://git.savannah.gnu.org/cgit/emacs/elpa.git/?h=externals/bbdb.
>>
>> This causes confusion because the website does not point to the true
>> source code that would be installed.
>>
>> This further causes confusion because both versions of `bbdb` are
>> extremely different notably the elpa version of bbdb contains a
>> `bbdb-site.el` file
>> (https://git.savannah.gnu.org/cgit/emacs/elpa.git/tree/lisp/bbdb-site.el?h=externals/bbdb)
>> whereas the non-gnu elpa version contains a `bbdb-site.el.in` file
>> (https://git.savannah.nongnu.org/cgit/bbdb.git/tree/lisp/bbdb-site.el.in)
>>
>> * Desired solutions
>>
>> 1. The elpa website should link to the bbdb source code that is defined
>>    in elpa-packages.
>> 2. Both versions of the elpa source code:
>>    https://git.savannah.gnu.org/cgit/emacs/elpa.git/tree/?h=externals/bbdb, and
>>    https://git.savannah.nongnu.org/cgit/bbdb.git/tree/, should be reconciled.
>>
>> I'd be willing to tackle solution 1 and possibly solution 2 but it isn't
>> clear to me where the source code for the elpa website is such that it
>> can be modified to point to the expected URL. It also isn't clear to me
>> if we should be keeping both versions of the source code or consolidate
>> since it seems like the version on gnu.org is no longer in use.
>>
>> Best,
>> Jules
>>
>> ---
>>
>> In GNU Emacs 31.0.50 (build 1, x86_64-pc-linux-gnu, GTK+ Version
>> 3.24.42, cairo version 1.18.0)
>> Repository revision: 9cb2a2040888c28587bed2b0902d9da90720f9a0
>> Repository branch: master
>> Windowing system distributor 'The X.Org Foundation', version 11.0.12101013
>> System Description: NixOS 24.11 (Vicuna)
>
> Adding Philip to this report
>
>
>
>

Jules Tamagnan <[email-masked]> writes:

> Jeremy Bryant <[email-masked]> writes:
>
>> Adding Philip to this report
>
> Brilliant, thank you. Let me know if there is anything I can do to help
> this along. I'm happy to take on fixes but am unsure how to make the
> proper modifications to the ELPA website and unsure how we should go
> about reconciling the differences between the versions:
>  - Should we remove the non-gnu version and improve the gnu version?

FWIW this is also an option, but I think we can avoid this.

>  - Should we remove the gnu version and use exclusively the non-gnu
>     version?
>  - Should we keep both but have the source be the same?

I'd vote for this one.

> Best,
> Jules

-- 
	Philip Kaludercic on peregrine